<template>
    <label class="ui-container">
        <input :checked="state"
               :disabled="disabled"
               type="checkbox"
               value="1"
               @change="change">
        <span class="checkmark" :disabled="disabled"></span>
    </label>
</template>

<script>
  export default {
    props: {
      value: {
        type: Boolean,
        required: false,
        default: true
      },
      disabled: {
        type: Boolean,
        required: false,
        default: false
      }
    },
    data () {
      return {
        state: false
      };
    },
    created () {
      this.state = this.value;
    },
    watch: {
      value () {
        if(this.disabled) {
          return;
        }
        this.state = this.value
        this.$emit('input', this.value);

      }
    },
    methods: {
      change (e) {
        this.$emit('input', e.target.checked);
        this.state = e.target.checked;
        this.$emit('change', e.target.checked);
      }
    }
  };
</script>

<style lang="scss">
    @import "static/css/variables/color.scss";
    /* Customize the label (the container) */
    label.ui-container {
        margin-right: 25px;
        vertical-align: top;
        position: relative;
        padding-left: 10px;
        margin-bottom: 12px;
        cursor: pointer;
        font-size: 22px;
        -webkit-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        input {
            position: absolute;
            opacity: 0;
            cursor: pointer;
        }
        /* Create a custom checkbox */
        .checkmark {
            position: absolute;
            top: 0;
            left: 0;
            height: 21px;
            width: 21px;
            transition: 0.15s;
            border: 1px solid #e9eff4;
            border-radius: 7px;
            background:#f8f8f8;

        }

        /* When the checkbox is checked, add a blue background */
        input:checked ~ .checkmark {
            background: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAsAAAAHCAYAAADebrddAAAATUlEQVR42mNgIADyjofVAfEfIDYkpLABiP8D8Xkg5iNWoQhMUBOIXwNxCl6FUAlRIL4PxP+AOA2nQiQNClAN//EqRNIgB8QXgPgoLoUA0yxMMSyRh98AAAAASUVORK5CYII=) no-repeat 50% 50% #e4f3e0;
            transition: 0.15s;
            &[disabled="disabled"] {
                background: url(data:image/svg+xml;base64,PHN2ZyB4bWxucz0iaHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmciIHdpZHRoPSIxMSIgaGVpZ2h0PSI5IiB2aWV3Qm94PSIwIDAgMTEgOSI+CiAgICA8cGF0aCBmaWxsPSIjQjdDNkQwIiBmaWxsLXJ1bGU9Im5vbnplcm8iIGQ9Ik05LjAwMy4yOTNsMS40MTUgMS40MTRMMy43MSA4LjQxNCAwIDQuNzA4bDEuNDEzLTEuNDE2TDMuNzEgNS41ODZ6Ii8+Cjwvc3ZnPgo=) no-repeat 50% 50% $inputBackground;
            }
        }

        /* Create the checkmark/indicator (hidden when not checked) */
        .checkmark:after {
            content: "";
            position: absolute;
            display: none;
        }

        /* Show the checkmark when checked */
        input:checked ~ .checkmark:after {
            display: block;
        }
    }
</style>
